var lWarn = {logln:function (o){}}; 
var lInfo = {logln:function (o){}};

var LOGFILE_NAME = "te-config.log";
lWarn = new Logger(LOGFILE_NAME);
lInfo = new Logger(LOGFILE_NAME);

var Utf8 = {
        
        // public method for url encoding
        encode : function (string) {
            string = string.replace(/\r\n/g,"\n");
            var utftext = "";
     
            for (var n = 0; n < string.length; n++) {
     
                var c = string.charCodeAt(n);
     
                if (c < 128) {
                    utftext += String.fromCharCode(c);
                }
                else if((c > 127) && (c < 2048)) {
                    utftext += String.fromCharCode((c >> 6) | 192);
                    utftext += String.fromCharCode((c & 63) | 128);
                }
                else {
                    utftext += String.fromCharCode((c >> 12) | 224);
                    utftext += String.fromCharCode(((c >> 6) & 63) | 128);
                    utftext += String.fromCharCode((c & 63) | 128);
                }
     
            }
     
            return utftext;
        },
     
        // public method for url decoding
        decode : function (utftext) {
            var string = "";
            var i = 0;
            var c = c1 = c2 = 0;
     
            while ( i < utftext.length ) {
     
                c = utftext.charCodeAt(i);
     
                if (c < 128) {
                    string += String.fromCharCode(c);
                    i++;
                }
                else if((c > 191) && (c < 224)) {
                    c2 = utftext.charCodeAt(i+1);
                    string += String.fromCharCode(((c & 31) << 6) | (c2 & 63));
                    i += 2;
                }
                else {
                    c2 = utftext.charCodeAt(i+1);
                    c3 = utftext.charCodeAt(i+2);
                    string += String.fromCharCode(((c & 15) << 12) | ((c2 & 63) << 6) | (c3 & 63));
                    i += 3;
                }
     
            }
     
            return string;
        }
     
    };

function getNewIdValue() {
    var idValue = 0;
    var baseNode = Property.getNode('entries');
    if (baseNode == null)
        return idValue;
    var oArrayNode = baseNode.getChildren();
    for ( var iIndex = 0; iIndex < oArrayNode.length; iIndex++) {
        var oChildNode = oArrayNode[iIndex];
        if (oChildNode.getChild('id') != null)
            if (oChildNode.getChild('id').getValue() != null)
                if (parseInt("" + oChildNode.getChild('id').getValue(),10) >= idValue)
                    idValue = parseInt("" + oChildNode.getChild('id').getValue(),10) + 1;
    }
    return idValue;
}

function putRecurrenceParameter(idValue,oParameterObject) {
	var succeded = true;
	var recurrenceBasePattern = new RegExp(/absolute|weekly/);
	var dayPattern = new RegExp(/MO|TU|WE|TH|FR|SA|SU/);
    if (oParameterObject.recurrence!=null) {	
    	var recurrenceBaseArray = recurrenceBasePattern.exec(oParameterObject.recurrence.recurrenceBase);
    	if (recurrenceBaseArray[0] != null) {
    		storeSubParameter(idValue + '/time/recurrenceBase', recurrenceBaseArray[0]);
	        if (recurrenceBaseArray[0]=='absolute') {
	            for (var iIndex=0;iIndex<oParameterObject.recurrence.timeArray.length;iIndex++){
	            	succeded = checkAndStoreStringParameter('entries/'+idValue + '/time/date/' + iIndex , oParameterObject.recurrence.timeArray[iIndex]);
	            }
	        } else {
	            for (var iIndex=0;iIndex<oParameterObject.recurrence.timeArray.length;iIndex++) {
	            	var recurenceArray = dayPattern.exec(oParameterObject.recurrence.timeArray[iIndex]);
	                if (recurenceArray[0] != null) {
	                	storeSubParameter(idValue + '/time/recurrence/' + iIndex , recurenceArray[0]);
	                } else {
	                	succeded = false;
	                }
	            }
	        }
    	} else {
    		succeded = false;
    	}
    }
    return succeded;
}

function putTimerParameter(idValue,oParameterObject) {
	var succeded = true;
    if (oParameterObject.time!=null) {
    	var timeBasePattern = new RegExp(/daily|sunrise|sunset|dawn|dusk|beforeHoliday|afterHoliday/);
    	var timeBaseArray = timeBasePattern.exec(oParameterObject.time.timeBase);
    	if (timeBaseArray[0] != null) {
    		storeSubParameter(idValue + '/time/timeBase', timeBaseArray[0]);
    	}
    	else {
    		succeded = false;
    	}
    	
    	succeded = checkAndStoreIntParameter('entries/'+idValue + '/time/offset', oParameterObject.time.offset) ? succeded : false;
        if (oParameterObject.time.limitAfter!=null)
        	succeded = checkAndStoreIntParameter('entries/'+idValue + '/time/limitAfter', oParameterObject.time.limitAfter) ? succeded : false;
        if (oParameterObject.time.limitBefore!=null)
        	succeded = checkAndStoreIntParameter('entries/'+idValue + '/time/limitBefore', oParameterObject.time.limitBefore) ? succeded : false;
        if (oParameterObject.time.random!=null)
        	succeded = checkAndStoreIntParameter('entries/'+idValue + '/time/random', parseInt(oParameterObject.time.random,10)) ? succeded : false;
        if (oParameterObject.time.propertyReference!=null)
        	succeded = checkAndStoreStringParameter('entries/'+idValue + '/time/propertyReference', oParameterObject.time.propertyReference) ? succeded : false;
    }
    return succeded;
}

function storeValue(sValue) {
    try {
        var result =  {};
        var oParameterObject = JSON.parse(unescape(sValue));

        var idValue = null;
        if (oParameterObject.id != null) {
            idValue = oParameterObject.id;
        } else {
            idValue = getNewIdValue();
        }
        result.id = idValue;
        var baseNode = Property.getNode('entries');
        if (baseNode != null)
            baseNode.removeChild(idValue);

        //the unescape already ensures to be string
        storeSubParameter(idValue + '/name', Utf8.encode(unescape(oParameterObject.name)));
        storeSubParameter(idValue + '/id', idValue);
        storeSubParameter(idValue+ '/conditions/enabled', true);

        if (!putActionParameter('entries/'+idValue,oParameterObject)) throw "wrong argument types";
        if (!putTimerParameter(idValue,oParameterObject)) throw "wrong argument types";    
        if (!putRecurrenceParameter(idValue,oParameterObject)) throw "wrong argument types";
        if (!putConditionParameter('entries/'+idValue,oParameterObject)) throw "wrong argument types";
        if (oParameterObject.scope!=null) {
            if (!checkAndStoreStringParameter('entries/'+idValue + '/scope',oParameterObject.scope)) throw "wrong argument types";
        } else {
        	storeSubParameter(idValue + '/scope','system-addon-timed-events');
        }
        
        if (oParameterObject.deleteCounter!=null) {
            if (!checkAndStoreIntParameter('entries/'+idValue + '/deleteCounter',oParameterObject.deleteCounter)) throw "wrong argument types";
        } else {
        	storeSubParameter(idValue + '/deleteCounter',0);
        }
        
        if (oParameterObject.metaData!=null) {
            if (!checkAndStoreStringParameter('entries/'+idValue + '/metaData', oParameterObject.metaData)) throw "wrong argument types";
        }
                
        setOneEvent(Property.getNode('entries/' + idValue));
        result.success = true;
        return result;
    } catch (e) {
        lWarn.logln("Fehler beim Speichern: " + e);
        for ( var i in e) {
            lWarn.logln(i + ': ' + e[i]);
        }
        //we could not store all data successfully so we cleanup
        baseNode.removeChild(idValue);
        result.success = false;
        return result;
    }
}

if (raisedEvent.name == 'system-addon-timed-events.config') {
	Property.load();
    lInfo.logln("TE-Config param action " + raisedEvent.parameter.actions);
    if (raisedEvent.parameter.actions == 'save') {
        lInfo.logln("TE-Config param value " + raisedEvent.parameter.value);       
        var result = storeValue(raisedEvent.parameter.value);
        Property.store();   
        var evt;
        if (result.success) {
            evt = new Event("system-addon-timed-events.saved", {id:result.id, complete:'success'});
        } else {
            evt = new Event("system-addon-timed-events.saved", {id:result.id, complete:'failed'});
        }
        evt.raise();
    }
    
    if (raisedEvent.parameter.actions == 'saveMultiple') {    	           	
    	
        lInfo.logln("TE-Config param value " + raisedEvent.parameter.value);       
        var fSuccess=true;
        var oParameterArray = JSON.parse(unescape(raisedEvent.parameter.value));
        for (var iIndex=0;iIndex<oParameterArray.length;iIndex++) {
        	lInfo.logln("TE-Config param Array # " + (iIndex+1) +  ' with ' + JSON.stringify(oParameterArray[iIndex]));
        	var result = storeValue(escape(JSON.stringify(oParameterArray[iIndex])))
            if (!result.success)
            	fSuccess=false;
        }
        Property.store();   
        var evt;
        if (fSuccess) {
            evt = new Event("system-addon-timed-events.saved", {id:result.id, complete:'success'});
        } else {
            evt = new Event("system-addon-timed-events.saved", {id:result.id, complete:'failed'});
        }
        evt.raise();
    }
    
    if (raisedEvent.parameter.actions == 'enable') {
        lInfo.logln("TE-Config enable value " +unescape( raisedEvent.parameter.id));

                
        var oIDObject=JSON.parse(unescape(raisedEvent.parameter.id));
        if (typeof(oIDObject)!='object')
            oIDObject=[oIDObject];

        for (var sKey in oIDObject) {
            
            var sanityCheck = Property.getNode('entries/'+oIDObject[sKey]);
            if (sanityCheck != null) {                
                storeSubParameter(oIDObject[sKey] + '/conditions/enabled', true);
            }
        }

        Property.store();
        var evt = new Event("system-addon-timed-events.saved", {id:raisedEvent.parameter.id});
        evt.raise();
    }
    if (raisedEvent.parameter.actions == 'disable') {
        lInfo.logln("TE-Config disable value " + unescape(raisedEvent.parameter.id));

        var oIDObject=JSON.parse(unescape(raisedEvent.parameter.id));
        if (typeof(oIDObject)!='object')
            oIDObject=[oIDObject];

        for (var sKey in oIDObject) {        
            var sanityCheck = Property.getNode('entries/'+oIDObject[sKey]);
            if (sanityCheck != null) {                
                storeSubParameter(oIDObject[sKey] + '/conditions/enabled', false);
            }
        }
        
        Property.store();
        var evt = new Event("system-addon-timed-events.saved", {id:raisedEvent.parameter.id});
        evt.raise();
    }
    if (raisedEvent.parameter.actions == 'setHoliday') {
        lInfo.logln("TE-Config setHoliday for " + unescape(raisedEvent.parameter.id) + ' with value ' + raisedEvent.parameter.value);

        var oIDObject=JSON.parse(unescape(raisedEvent.parameter.id));
        if (typeof(oIDObject)!='object')
            oIDObject=[oIDObject];

        for (var sKey in oIDObject) {        
            var sanityCheck = Property.getNode('entries/'+oIDObject[sKey]);
            if (sanityCheck != null) {                
            	if (raisedEvent.parameter.value=='on')
            		storeSubParameter(oIDObject[sKey] + '/conditions/states/holiday', 'on');
            	if (raisedEvent.parameter.value=='off')
            		storeSubParameter(oIDObject[sKey] + '/conditions/states/holiday', 'off');
            	/// remove heir
            }
        }
        
        Property.store();
        var evt = new Event("system-addon-timed-events.saved", {id:raisedEvent.parameter.id});
        evt.raise();
    }
    if (raisedEvent.parameter.actions == 'delete') {
        lInfo.logln("TE-Config delete value " + unescape(raisedEvent.parameter.id));

        
        var oIDObject=JSON.parse(unescape(raisedEvent.parameter.id));
        if (typeof(oIDObject)!='object')
            oIDObject=[oIDObject];
        for (var sKey in oIDObject) {
            
            resetOneEvent('dynamic/scheduledFixedEvents/' +oIDObject[sKey]);
            resetOneEvent('dynamic/scheduledMultipleEvents/' + oIDObject[sKey]);
            resetOneEvent('dynamic/scheduledDynamicEvents/' + oIDObject[sKey]);
            resetOneEvent('dynamic/countdownTimer/' + oIDObject[sKey]);
            
            var baseNode = Property.getNode('entries');
            if (baseNode != null)
                baseNode.removeChild(oIDObject[sKey]);
        }
        Property.store();
        var evt = new Event("system-addon-timed-events.saved",  {id:raisedEvent.parameter.id});
        evt.raise();
    }
    if (raisedEvent.parameter.actions == 'updateTimer') {
        lInfo.logln("TE-Config updateTrigger ");     
        queueAllTimedEvents();
    }
    if (raisedEvent.parameter.actions =='suntime-reschedule') {
        lInfo.logln("TE-Config suntime-reschedule "); 
        queueAllTimedEvents();
    }
}

if (raisedEvent.name == 'system-addon-timed-events.random_action_execute') {
    var path=raisedEvent.parameter.path;
    if (path!=null) {
        lInfo.logln("system-addon-timed-events.random_action_execute for " + path); 
        Property.load();
        var baseNode=Property.getNode(path);
        if (baseNode!=null){
            var delayNode=baseNode.getChild('time/random');
            if (delayNode!=null) {
                var deltaTime=Math.floor(delayNode.getValue() *  Math.random());
                lInfo.logln("system-addon-timed-events.random_action_execute : Deltatime should be " + deltaTime);
                var timerEvent = new TimedEvent('action_execute', '+' + deltaTime, {
                    path: path                         
                });     
                lInfo.logln("system-addon-timed-events.random_action_execute : queueing as " + timerEvent.raise());
            }
        } 
    } else
        lInfo.logln("system-addon-timed-events.random_action_execute : no path parameter");
}

if (raisedEvent.name == 'system-addon-timed-events.refreshCounter') {
    var path=raisedEvent.parameter.path;
    if (path!=null) {
        lInfo.logln("system-addon-timed-events.refreshCounter for " + path); 
        Property.load();
        var baseNode=Property.getNode(path);
        if (baseNode!=null){
        	var counterNode=baseNode.getChild('deleteCounter');
        	if (counterNode!=null) {
        		var iAnzahl=counterNode.getValue();
        		if (iAnzahl==1)
        			new Event('system-addon-timed-events.config',{'actions':'delete','id':baseNode.getChild('id').getValue()}).raise();
        		else
            		if (iAnzahl>1)
            			counterNode.setValue(iAnzahl-1);
        	}
        } 
    } else
        lInfo.logln("system-addon-timed-events.refreshCounter : no path parameter");
}

